package ir.kargar.karamad;

import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import ir.kargar.karamad.place.MyPlaceSpinerAdapter;
import ir.kargar.karamad.place.MyPlaces;
import ir.kargar.karamad.setting.MyUserManager;

public class LoginActivity extends AppCompatActivity {
    Spinner spinerPlaces;
    TextView usernameTV, passwordTV, forgetPasswordBTN;
    Button loginBTN;
    CheckBox rememberMeCHBOX;

//    List<MyPlaces> placesList;
    String[] placesName;
    String[] baseUrl ;
    String[] placeAddress;
    String[] placePhoneNumber;
    int[] placeImageId;

    MyPlaces selectedPalce=new MyPlaces("","","","",R.drawable.store_icon);

    String userName;
    String password;
    MyUserManager myUserManager;
    MyPlaceSpinerAdapter adapter;
    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.activity_login);
        setContentView(R.layout.activity_login);
        //RTL Direction
        getWindow().getDecorView().setLayoutDirection(View.LAYOUT_DIRECTION_RTL);
        myUserManager=new MyUserManager(this);
        initCustomSpinner();
        //find items
        findItemLoginForm();

        Listenitems();

        usernameTV.setText(myUserManager.getUserName());
        passwordTV.setText(myUserManager.getPassword());
        int position=myUserManager.getPosition();
        spinerPlaces.setSelection(position);

        //Todo set store name
        if(!(myUserManager.getUserName().equals("")) && !(myUserManager.getPassword().equals("")))
        {
            //Todo CHECK
            //go to main activity
            // Create the text message with a string
            //Intent activity = new Intent(LoginActivity.this, MainActivity.class);
            // Start the activity
            //startActivity(activity);
            // Close Login Activity
            //finish();
        }
        }

    private void Listenitems() {
        //when select item in spiner
        spinerPlaces.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
               // Toast.makeText(LoginActivity.this,placesName[position],Toast.LENGTH_LONG).show();
                if(position>0) {
                    //findViewById(R.id.form_login).setVisibility(View.VISIBLE);
                    MyPlaces thisPalce=new MyPlaces(placesName[position],baseUrl[position],placeAddress[position], placePhoneNumber[position], placeImageId[position]);
                    selectedPalce=thisPalce;

                    //Todo save selectedPlaces in sharepref
                    myUserManager.savePlaceInformation(position,placesName[position],baseUrl[position],placeAddress[position], placePhoneNumber[position], placeImageId[position]);
                }
                else { //position==0
                    //findViewById(R.id.form_login).setVisibility(View.INVISIBLE);
                    selectedPalce.setPlaceName("");
                    selectedPalce.setBaseUrl("");
                    selectedPalce.setPlaceAddress("");
                    selectedPalce.setPlacePhoneNumber("");
                    selectedPalce.setPlaceImageId(R.drawable.store_icon);
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        //Click on Login button
        loginBTN.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String nameOfUser = null;
                // Get value in textViews
                userName = usernameTV.getText().toString().trim();
                password = passwordTV.getText().toString();
                //String msg= userName + " " + password;
                //Toast.makeText(getApplicationContext(), msg, Toast.LENGTH_LONG).show();
                if(selectedPalce.getBaseUrl()=="")
                {
                    String msg = getString(R.string.selectPlace);
                    showToast(msg);
                    spinerPlaces.requestFocus();
                }
                else if (userName.isEmpty()) {
                    //user name is Empty
                    String msg = getString(R.string.msgErrorLoginUser) ;
                    showToast(msg);
                    usernameTV.requestFocus();
                } else if (password.length() < 4) {
                    // lenght of password  is higher than 4
                    String msg = getString(R.string.msgErrorLoginPassword);
                    showToast(msg);
                    passwordTV.requestFocus();
                } else {
                    //Todo request to api and find name and last name with username and password
                    ////////////nameOfUser=request api and change  next line
                    nameOfUser = getString(R.string.defaultUser);
                    //we We considered  username=1 and password =1234in api
                    if (userName.equals("1") && password.equals("1234"))  // this line delete and next line true
                    //if(nameOfUser !=null)
                    {
                        //save in sharepreferences
                        myUserManager.saveUserName(userName);
                        if(rememberMeCHBOX.isChecked()){
                            myUserManager.savePassword(password);
                        }
                        else{
                            myUserManager.savePassword("");
                        }

                        // Create the text message with a string
                        Intent activity = new Intent(LoginActivity.this, MainActivity.class);
                        // Start the activity
                        startActivity(activity);
                        // Close Login Activity
                        finish();
                    } else {
                        String msg = getString(R.string.msgErroLogin);
                        showToast(msg);
                    }
                }
            }
        });

        //Click forget password
        forgetPasswordBTN.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent activity = new Intent(LoginActivity.this, ForgetPasswordActivity.class);
                startActivity(activity);
            }
        });
    }

    private void findItemLoginForm() {
        usernameTV = (TextView) findViewById(R.id.usernameTV);
        passwordTV =(TextView) findViewById(R.id.passwordTV);
        loginBTN = (Button) findViewById(R.id.loginBTN);
        forgetPasswordBTN = (TextView) findViewById(R.id.forgetPasswordBTN);
        rememberMeCHBOX=(CheckBox)findViewById(R.id.rememberMeCHBOX);
    }

    private void initCustomSpinner() {
        spinerPlaces=(Spinner)findViewById(R.id.spinnerPlaces);

//        placesList.clear();
        //Todo get places info from web
        //we get ips - places name and number of places from api
        int numberOfStore=11; // then change .get from select count

        placesName=new String[numberOfStore];
        baseUrl=new String[numberOfStore];
        placeAddress=new String[numberOfStore];
        placePhoneNumber =new String[numberOfStore];
        placeImageId =new int[numberOfStore];

        placesName[0]= getString(R.string.selectPlace);
        baseUrl[0]="";
        placeAddress[0]="";
        placePhoneNumber[0]="";
        placeImageId[0]=0;

//        String placesName = getString(R.string.selectPlace);
//        String baseUrl="";
//        String placeAddress="";
//        String placePhoneNumber="";
//        int placeImageId=0;
//        MyPlaces placeItem=new MyPlaces(placesName,baseUrl,placeAddress,placePhoneNumber,placeImageId);
//
//        placesList.add(new MyPlaces(placesName,baseUrl,placeAddress,placePhoneNumber,placeImageId));
        selectedPalce=new MyPlaces(placesName[0],baseUrl[0],placeAddress[0], placePhoneNumber[0], placeImageId[0]);

//        selectedPalce=placeItem;

        //Todo  set form json
        for (int i=1 ; i < numberOfStore ;i++){   //but when set manualy
            placesName[i]= getString(R.string.store)+ " " + i;
            baseUrl[i]="192.168.1." + i;
            placeAddress[i]="maybod";
            placePhoneNumber[i]="03530000000";
            placeImageId[i] = R.drawable.store_icon;
//            placesName= getString(R.string.store)+ " " + i;
//            baseUrl="192.168.1." + i;
//            placeAddress="maybod";
//            placePhoneNumber="03530000000";
//            placeImageId = R.drawable.store_icon;

//            placeItem=new MyPlaces(placesName,baseUrl,placeAddress,placePhoneNumber,placeImageId);//
//            placesList.add(placeItem);
        }

         adapter=new MyPlaceSpinerAdapter(this,placesName, placeImageId);
//        adapter=new MyPlaceSpinerAdapter(this,placesList);
        spinerPlaces.setAdapter(adapter);
    }

    public void showToast(String msg) {
        LayoutInflater inflater =getLayoutInflater();
        View layout = inflater.inflate(R.layout.mytoast, (ViewGroup) findViewById(R.id.custom_toast_Layout));
        TextView tv = (TextView) layout.findViewById(R.id.txtvw);
        tv.setText(msg);
        Toast toast = new Toast(getApplicationContext());
        toast.setDuration(Toast.LENGTH_LONG);
        toast.setView(layout);
        toast.show();
    }
}
