package ir.kargar.karamad;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.fragment.app.FragmentTransaction;

import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;

import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.google.android.material.navigation.NavigationBarView;

import ir.kargar.karamad.setting.MyUserManager;

public class MainActivity extends AppCompatActivity {
    MyUserManager myUserManager;
    Menu menuNav;
    MenuItem profileItem,cartItem,homeItem,categoryItem;
    BottomNavigationView mainBottomNavigation;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        //RTL Direction
       //  getWindow().getDecorView().setLayoutDirection(View.LAYOUT_DIRECTION_RTL);
        setSupportActionBar((Toolbar) findViewById(R.id.mainToolbar));
        findItemMenu();
       //listenItemMenu();

        mainBottomNavigation.setOnItemSelectedListener(new NavigationBarView.OnItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {
                FragmentTransaction fragmentTransaction=getSupportFragmentManager().beginTransaction();
                switch (item.getItemId()){
                    case R.id.homeItem:
                        FragmentTransaction fragmentTransaction4=getSupportFragmentManager().beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_container,new HomeFragment());
//                        fragmentTransaction.addToBackStack("HomeFragment");
                        fragmentTransaction.commit();
                        break;
                        case R.id.profileItem:
                        FragmentTransaction fragmentTransaction2=getSupportFragmentManager().beginTransaction();
                        fragmentTransaction2.replace(R.id.nav_host_container,new ProfileFragment());
                        //fragmentTransaction.addToBackStack("ProfileFragment");
                        fragmentTransaction2.commit();
                        break;
                    case R.id.cartItem:
//                        FragmentTransaction fragmentTransaction2=getSupportFragmentManager().beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_container,new CartFragment());
                        //fragmentTransaction.addToBackStack("ProfileFragment");
                        fragmentTransaction.commit();
                        break;
                    case R.id.categoryItem:
//                        FragmentTransaction fragmentTransaction3=getSupportFragmentManager().beginTransaction();
                        fragmentTransaction.replace(R.id.nav_host_container,new CategoryFragment());
                        //fragmentTransaction.addToBackStack("ProfileFragment");
                        fragmentTransaction.commit();
                        break;

                }
                return true;
            }
        });
        mainBottomNavigation.setOnItemReselectedListener(new NavigationBarView.OnItemReselectedListener() {
            @Override
            public void onNavigationItemReselected(@NonNull MenuItem item) {

            }
        });
        //default Item
        mainBottomNavigation.setSelectedItemId(R.id.homeItem);

        //myUserManager.saveUserName("");


        // get sended data
        //String userName=sharedPreferences.getString("userName","0");
       // String nameOfUser=sharedPreferences.getString("nameOfUser","Gest");






    }
//    private void replaceFragment(Fragment fragment)
//    {
//        FragmentTransaction fragmentTransaction=getSupportFragmentManager().beginTransaction();
//        fragmentTransaction.replace(R.id.mainFragmentContainer,fragment);
//        //fragmentTransaction.addToBackStack("ProfileFragment");
//        fragmentTransaction.commit();
//    }
    private void listenProfileItemMenu() {
        profileItem.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
            @Override
            public boolean onMenuItemClick(MenuItem item) {
                FragmentTransaction fragmentTransaction=getSupportFragmentManager().beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_container,new ProfileFragment());
                //fragmentTransaction.addToBackStack("ProfileFragment");
                fragmentTransaction.commit();
//                replaceFragment(new ProfileFragment());
                return false;
            }
        });
    }
    private void listenCartItemMenu() {
        cartItem.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
            @Override
            public boolean onMenuItemClick(MenuItem item) {
                FragmentTransaction fragmentTransaction=getSupportFragmentManager().beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_container,new CartFragment());
                //fragmentTransaction.addToBackStack("CartFragment");
                fragmentTransaction.commit();
//                replaceFragment(new CartFragment());
                return false;
            }
        });
    }
    private void listenHomeItemMenu(){
        homeItem.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
            @Override
            public boolean onMenuItemClick(MenuItem item) {
                FragmentTransaction fragmentTransaction=getSupportFragmentManager().beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_container,new HomeFragment());
                //fragmentTransaction.addToBackStack("mainFragment");
                fragmentTransaction.commit();
//                replaceFragment(new HomeFragment());
                return false;
            }
        });
    }
    private void listenCategoryItemMenu(){
        categoryItem.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
            @Override
            public boolean onMenuItemClick(MenuItem item) {
                FragmentTransaction fragmentTransaction=getSupportFragmentManager().beginTransaction();
                fragmentTransaction.replace(R.id.nav_host_container,new CategoryFragment());
                //fragmentTransaction.addToBackStack("CategoryFragment");
                fragmentTransaction.commit();
                return false;
            }
        });
    }
    private void listenItemMenu() {
        listenProfileItemMenu();
        listenCartItemMenu();
        listenHomeItemMenu();
        listenCategoryItemMenu();
    }

    private void findItemMenu() {
        mainBottomNavigation =findViewById(R.id.mainBottomNavigation);
        //menu
        menuNav = mainBottomNavigation.getMenu();
        //Items
        profileItem = menuNav.findItem(R.id.profileItem);
        cartItem = menuNav.findItem(R.id.cartItem);
        homeItem = menuNav.findItem(R.id.homeItem);
        categoryItem = menuNav.findItem(R.id.categoryItem);
    }


    //Create my menu
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_main,menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(@NonNull MenuItem item) {
        if(item.getItemId()==R.id.logoutItem)
        {
            //logout
            //Erase Perefrences
            //go to main activity
            Intent activity = new Intent(MainActivity.this, LoginActivity.class);
            startActivity(activity);
            finish();
        }
        return super.onOptionsItemSelected(item);
    }
}
