package ir.kargar.karamad.product;

import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.List;

import ir.kargar.karamad.R;

public class ProductsRecyclerAdapter extends RecyclerView.Adapter<ProductsRecyclerAdapter.ViewHolder> implements View.OnClickListener {
    Context context;
    List<Products> productsList;
    LayoutInflater inflater;

    public ProductsRecyclerAdapter(Context context, List<Products> productsList) {
        this.context = context;
        this.productsList = productsList;
        this.inflater=LayoutInflater.from(context);
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view=inflater.inflate(R.layout.product_item_layout,parent,false);
        //click listener
        view.setOnClickListener(this);
        return new ViewHolder(view);
    }

    @SuppressLint("ResourceAsColor")
    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        Products productItem=productsList.get(position);
        holder.ProductCodeTV.setText(productItem.getCode());
        holder.ProductTitleTV.setText(productItem.getTitle());
        holder.productPriceTV.setText(productItem.getPrice().toString());

        if(productItem.getHasQty()){
            holder.productExistTV.setText(R.string.exist);
            holder.productExistTV.setBackgroundColor(R.color.colorAccent);
        }
        else {
            holder.productExistTV.setText(R.string.noExist);
            holder.productExistTV.setBackgroundColor(R.color.notColor);
        }

        //holder.imgPlace.setImageResource(productItem.getPlaceImageId());


    }

    @Override
    public int getItemCount() {
        return productsList.size();
    }

    @Override
    public void onClick(View v) {
        int itemPosition=0;
        String msg= "Hi";
        Toast.makeText(context,msg,Toast.LENGTH_SHORT).show();
    }

    // define internal class
    public class ViewHolder extends RecyclerView.ViewHolder{

        public TextView ProductCodeTV;
        public TextView ProductTitleTV;
        public TextView productPriceTV;
        public TextView productDetailTV;
        public TextView productExistTV;
        public TextView VahedPoolTV;
        public Button addCartBTN;


        //public ImageView imgPlace;

        public ViewHolder(@NonNull final View itemView) {
            super(itemView);

            ProductCodeTV= itemView.findViewById(R.id.ProductCodeTV);
            ProductTitleTV= itemView.findViewById(R.id.ProductTitleTV);
            productPriceTV= itemView.findViewById(R.id.productPriceTV);
            productDetailTV= itemView.findViewById(R.id.productDetailTV);
            productExistTV= itemView.findViewById(R.id.productExistTV);
            VahedPoolTV= itemView.findViewById(R.id.VahedPoolTV);
            addCartBTN= itemView.findViewById(R.id.addCartBTN);
            //imgPlace= itemView.findViewById(R.id.imgPlace);

        }
    }


}
